DECLARE SUB AppendProgram (s$)
DEFINT A-Z
'$INCLUDE: 'ZZTQED.BI'

SUB AppendProgram (s$)
 OPEN "ZZTQED.DIR\0.555" FOR BINARY AS #12
 IF clipstat.cycle < 0 THEN clipstat.proglen = 0: clipstat.cycle = 3
 IF clipstat.proglen = -1000 THEN
  SessionCheck 12
  GET #12, , n: PUT #12, n + 7, s$
  n = n + LEN(s$): PUT #12, 5, n
 ELSE
  n = LEN(s$): PUT #12, sessionid&: PUT #13, , n: PUT #13, , s$
  clipstat.proglen = -1000
 END IF
 CLOSE #12
END SUB

SUB CreateNewWorld
 IF LEN(DIR$(filename$)) THEN PRINT "File already exists": END
 world.ident = -1: world.health = 100: world.saved = CHR$(0)
 LetCounted world.wname, LEFT$(filename$, LEN(filename$) - 4)
 ERASE bcolor, bkind, stats, world.flags
 FOR y = 1 TO 25
  FOR x = 1 TO 60
   bstat(y, x) = -1
  NEXT x
 NEXT y
 bkind(1, 1) = 4: bcolor(1, 1) = &H1F: bstat(1, 1) = 0
 stats(0).x = CHR$(1): stats(0).y = CHR$(1): stats(0).cycle = 1
 LetCounted bhead.title, "TITLE SCREEN"
 bfoot.maxshots = CHR$(255)
 DoMacro "*W"
 OPEN filename$ FOR BINARY AS #1
 PUT #1, , world
 WriteBoard
 CLOSE #1
END SUB

SUB DoMacro (m$)
 s$ = ""
DoMacro.1:
 IF LEN(DIR$(LEFT$(filename$, LEN(filename$) - 3) + "MAC")) THEN
  OPEN LEFT$(filename$, LEN(filename$) - 3) + "MAC" FOR INPUT AS #19
 ELSE
  OPEN "ZZTQED.MAC" FOR INPUT AS #19
 END IF
 WHILE NOT EOF(19)
  LINE INPUT #19, p$
  IF LEFT$(p$, 3) = m$ + ":" THEN
   FOR i = 4 TO LEN(p$)
    SELECT CASE MID$(p$, i, 1)
     CASE "0" TO "9": prefix = prefix * 10 + ASC(MID$(p$, i, 1)) - 48
     CASE "-": prefix = -prefix
     CASE "+": prefix = prefix + submode
     CASE "*": prefix = submode * prefix
     CASE "%": prefix = submode MOD prefix
     CASE "/": prefix = submode \ prefix
     CASE "(": prefix = prefix - 1
     CASE ")": prefix = prefix + 1
     CASE ";": prefix = 0
     CASE "[": prefix = -1
     CASE "]": prefix = 1
     CASE "{": submode = -1
     CASE "}": submode = 1
     CASE "~": prefix = NOT prefix
     CASE "?": IF prefix = 0 THEN EXIT FOR
     CASE "!": IF prefix THEN EXIT FOR
     CASE ":": m$ = MID$(p$, i + 1, 2): i = i + 2
     CASE "@": CopyProgram prefix, submode
     CASE "#": curmode = 0
     CASE "'": submode = 0
     CASE "$": i = 3
     CASE "\": submode = prefix: prefix = 0
     CASE "&"
      CLOSE #19: IF i = LEN(RTRIM$(p$)) THEN EXIT SUB
      OPEN RTRIM$(MID$(p$, i + 1)) FOR INPUT AS #19: EXIT FOR
     CASE "_"
      MID$(p$, i, 1) = " ": i = INSTR(i + 1, p$, "_"): MID$(p$, i, 1) = " "
     CASE "|": SWAP submode, prefix
     CASE "<": LoadBoard
     CASE ">": SaveBoard
     CASE "=": prefix = prefix = submode
     CASE ","
      i = i + 1: SELECT CASE MID$(p$, i, 1)
       CASE "b": prefix = backbufsize
       CASE "c": prefix = bcolor(cury, curx)
       CASE "e": prefix = ASC(bfoot.exits(3))
       CASE "h": prefix = kcycle(submode)
       CASE "i": prefix = kchar(submode)
       CASE "j": prefix = kcolor(submode)
       CASE "k": prefix = bkind(cury, curx)
       CASE "m": prefix = bmark(cury, curx)
       CASE "n": prefix = ASC(bfoot.exits(0))
       CASE "o": prefix = curmode
       CASE "p": prefix = bufcolor(submode)
       CASE "q": prefix = bufkind(submode)
       CASE "r": prefix = curcolor
       CASE "s": prefix = ASC(bfoot.exits(1))
       CASE "t": prefix = bfoot.maxstat
       CASE "u": prefix = world.curboard
       CASE "v": prefix = world.maxboard
       CASE "w": prefix = ASC(bfoot.exits(2))
       CASE "x": prefix = curx
       CASE "y": prefix = cury
       CASE "z": prefix = bstat(cury, curx)
       CASE "B": backbufsize = prefix
       CASE "C": bcolor(cury, curx) = prefix
       CASE "E": bfoot.exits(3) = CHR$(prefix)
       CASE "H": kcycle(submode) = prefix
       CASE "I": kchar(submode) = prefix
       CASE "J": kcolor(submode) = prefix
       CASE "K": bkind(cury, curx) = prefix
       CASE "M": bmark(cury, curx) = prefix
       CASE "N": bfoot.exits(0) = CHR$(prefix)
       CASE "O": curmode = prefix
       CASE "P": bufcolor(submode) = prefix
       CASE "Q": bufkind(submode) = prefix
       CASE "R": curcolor = prefix
       CASE "S": bfoot.exits(1) = CHR$(prefix)
       CASE "T": bfoot.maxstat = prefix
       CASE "U": world.curboard = prefix
       CASE "V": world.maxboard = prefix
       CASE "W": bfoot.exits(2) = CHR$(prefix)
       CASE "X": curx = prefix
       CASE "Y": cury = prefix
       CASE "Z": bstat(cury, curx) = prefix
      END SELECT
     CASE "`"
      i = i + 1: SELECT CASE MID$(p$, i, 1)
       CASE "a": prefix = world.ammo
       CASE "d": prefix = ASC(bfoot.dark)
       CASE "e": prefix = world.energy
       CASE "g": prefix = world.gems
       CASE "h": prefix = world.health
       CASE "k": prefix = ASC(MID$(world.keys, submode, 1))
       CASE "l": prefix = world.light
       CASE "o": prefix = ASC(bfoot.maxshots)
       CASE "q": prefix = world.tick
       CASE "s": prefix = world.score
       CASE "t": prefix = world.torches
       CASE "u": prefix = bfoot.timelimit
       CASE "v": prefix = world.time
       CASE "x": prefix = ASC(bfoot.enterx)
       CASE "y": prefix = ASC(bfoot.entery)
       CASE "z": prefix = ASC(bfoot.restartzap)
       CASE "A": world.ammo = prefix
       CASE "D": bfoot.dark = CHR$(prefix)
       CASE "E": world.energy = prefix
       CASE "G": world.gems = prefix
       CASE "H": world.health = prefix
       CASE "K": MID$(world.keys, submode, 1) = CHR$(prefix)
       CASE "L": world.light = prefix
       CASE "O": bfoot.maxshots = CHR$(prefix)
       CASE "Q": world.tick = prefix
       CASE "S": world.score = prefix
       CASE "T": world.torches = prefix
       CASE "U": bfoot.timelimit = prefix
       CASE "V": world.time = prefix
       CASE "X": bfoot.enterx = CHR$(prefix)
       CASE "Y": bfoot.entery = CHR$(prefix)
       CASE "Z": bfoot.restartzap = CHR$(prefix)
      END SELECT
     CASE "."
      i = i + 1: SELECT CASE MID$(p$, i, 1)
       CASE "c": prefix = ASC(clipstat.ucolor)
       CASE "f": prefix = clipstat.follower
       CASE "k": prefix = ASC(clipstat.ukind)
       CASE "l": prefix = clipstat.leader
       CASE "p": prefix = clipstat.proglen
       CASE "q": prefix = clipstat.cycle
       CASE "u": prefix = ASC(clipstat.para)
       CASE "v": prefix = ASC(MID$(clipstat.para, 2))
       CASE "w": prefix = ASC(MID$(clipstat.para, 3))
       CASE "x": prefix = clipstat.xd
       CASE "y": prefix = clipstat.yd
       CASE "C": clipstat.ucolor = CHR$(prefix)
       CASE "F": clipstat.follower = prefix
       CASE "K": clipstat.ukind = CHR$(prefix)
       CASE "L": clipstat.leader = prefix
       CASE "P": clipstat.proglen = prefix: clipstat.instptr = 0
       CASE "Q": clipstat.cycle = prefix
       CASE "U": MID$(clipstat.para, 1, 1) = CHR$(prefix)
       CASE "V": MID$(clipstat.para, 2, 1) = CHR$(prefix)
       CASE "W": MID$(clipstat.para, 3, 1) = CHR$(prefix)
       CASE "X": clipstat.xd = prefix
       CASE "Y": clipstat.yd = prefix
      END SELECT
     CASE "^"
      i = i + 1: SELECT CASE MID$(p$, i, 1)
       CASE ";": MoveCursor 0, 0
       CASE "&": prefix = prefix AND submode
       CASE "|": prefix = prefix OR submode
       CASE "<": bmark(cury, curx) = 0
       CASE ">": bmark(cury, curx) = -1
       CASE "[": bmark(suby, subx) = 0
       CASE "]": bmark(suby, subx) = -1
       CASE "=": SetPassage
       CASE "a": s$ = GetCounted$(bhead.title)
       CASE "b": CirculateBackbuf
       CASE "c": FindPassageC
       CASE "d": defcolor = prefix
       CASE "e": s$ = STRING$(prefix + 1, 0): EditCountedString s$
       CASE "f": LetCounted world.flags(prefix), s$
       CASE "g": s$ = GetCounted$(s$)
       CASE "h": MoveCursor -1, 0
       CASE "i": prefix = INSTR(s$, CHR$(prefix))
       CASE "j": MoveCursor 0, 1
       CASE "k": MoveCursor 0, -1
       CASE "l": MoveCursor 1, 0
       CASE "m": s$ = MID$(s$, prefix)
       CASE "n": s$ = LEFT$(s$, prefix)
       CASE "p": FindPassage prefix
       CASE "v": dispmode = prefix
       CASE "w": LoadArea
       CASE "x": prefix = ASC(clipstat.x)
       CASE "y": prefix = ASC(clipstat.y)
       CASE "0": MassSet 0, 0
       CASE "A": LetCounted bhead.title, s$
       CASE "C": MassSet prefix, -1
       CASE "D": MassDelStat
       CASE "F": MassFloor
       CASE "K": MassSet -1, prefix
       CASE "M": MassSet curcolor, prefix
       CASE "P": MassPaste
       CASE "R": RANDOMIZE TIMER
       CASE "S": MassShuffle
       CASE "W": SaveArea
       CASE "?": prefix = defcolor
       CASE "#": prefix = LEN(s$)
       CASE "$": IF LEN(s$) THEN prefix = ASC(s$)
       CASE "^": p$ = "  :" + s$: s$ = "": i = 3
      END SELECT
     CASE "a": prefix = submode
     CASE "b": prefix = SelectBoard(prefix, 0)
     CASE "c": prefix = clipcolor
     CASE "d": DelStat prefix
     CASE "e": prefix = AddStat(subx, suby)
     CASE "f": FloodFill prefix
     CASE "g": m$ = RIGHT$(RTRIM$(STR$(prefix)), 2)
     CASE "h": m$ = HexByte$(prefix)
     CASE "i": InvertMark
     CASE "j": curx = subx: cury = suby: MoveCursor 0, 0
     CASE "k": prefix = clipkind
     CASE "l": ChangeLinkStat prefix, submode
     CASE "m": MarkBlock prefix, submode
     CASE "n": IF NextMarked THEN i = 3
     CASE "o": MassCopy subx, suby
     CASE "p": PasteClip subx, suby
     CASE "q"
      curx = curx + 1: IF curx = 61 THEN curx = 1: cury = cury + 1
      IF cury = 21 THEN cury = 1 ELSE i = 3
     CASE "r": CLOSE #19: GOTO DoMacro.1
     CASE "s"
      clipstat.x = stats(prefix).x: clipstat.y = stats(prefix).y
      stats(prefix) = clipstat
     CASE "t": s$ = ""
     CASE "u": ERASE bmark
     CASE "v": prefix = SelectChar(prefix)
     CASE "w": SWAP subx, curx: SWAP suby, cury
     CASE "x": prefix = subx
     CASE "y": prefix = suby
     CASE "z": SWAP subx, suby
     CASE "A": submode = prefix
     CASE "B": prefix = SelectBoard(prefix, 1)
     CASE "C": clipcolor = prefix
     CASE "D": prefix = prefix * 2
     CASE "E": prefix = AddStat(curx, cury)
     CASE "F": FlipBlock subx, suby
     CASE "G": prefix = SGN(prefix)
     CASE "H": prefix = prefix \ 2
     CASE "I": s$ = s$ + LTRIM$(RTRIM$(STR$(prefix)))
     CASE "J": s$ = s$ + CHR$(prefix)
     CASE "K": clipkind = prefix
     CASE "L": IF submode > 0 THEN submode = submode - 1: i = 3
     CASE "M": FindMatch prefix
     CASE "N": prefix = NextMarked
     CASE "P": PasteClip curx, cury
     CASE "R": prefix = INT(RND * prefix)
     CASE "S": clipstat = stats(prefix)
     CASE "U": clipstat.cycle = -1
     CASE "V": prefix = SelectColor(prefix)
     CASE "W": s$ = s$ + CHR$(13): AppendProgram s$: s$ = ""
     CASE "X": subx = prefix
     CASE "Y": suby = prefix
     CASE "Z": IF prefix = 0 THEN CLOSE #19: EXIT SUB
     CASE CHR$(34): s$ = s$ + MID$(p$, i + 1): EXIT FOR
    END SELECT
   NEXT i
  END IF
 WEND
 CLOSE #19
END SUB

SUB LoadArea
 IF DIR$("ZZTQED.DIR\0.557") = "" THEN EXIT SUB
 OPEN "ZZTQED.DIR\0.557" FOR BINARY AS #1
 DO
  GET #1, , x: GET #1, , y: IF x = 256 THEN EXIT DO
  x = x + curx: y = y + cury: GET #1, , c: GET #1, , k
  IF x > 0 AND x <= 60 AND y > 0 AND y <= 25 THEN
   IF bmark(y, x) GOTO LoadArea.1
   IF bstat(y, x) = 0 GOTO LoadArea.1
   bcolor(y, x) = c AND 255: bkind(y, x) = k AND 255
   IF c < 0 THEN
    k = AddStat(x, y)
    IF k > 0 THEN
     GET #1, , stats(k)
     stats(k).x = CHR$(x): stats(k).y = CHR$(y)
     stats(k).proglen = 0
    ELSE
     SEEK #1, SEEK(1) + LEN(clipstat)
    END IF
   ELSE
    DelStat bstat(y, x)
   END IF
  ELSE
LoadArea.1:
   IF c < 0 THEN SEEK #1, SEEK(1) + LEN(clipstat)
  END IF
 LOOP
 CLOSE #1
END SUB

SUB MassFillRandom
 RANDOMIZE TIMER
 FOR y = 1 TO 25
  FOR x = 1 TO 60
   IF bmark(y, x) <> 0 AND bstat(y, x) <> 0 THEN
    i = INT(RND * backbufsize)
    bcolor(y, x) = bufcolor(i)
    bkind(y, x) = bufkind(i)
   END IF
  NEXT x
 NEXT y
END SUB

SUB SaveArea
 OPEN "ZZTQED.DIR\0.557" FOR BINARY AS #1
 FOR x = 1 TO 60
  FOR y = 1 TO 25
   IF bmark(y, x) THEN
    x = x - curx: y = y - cury: PUT #1, , x: PUT #1, , y
    x = x + curx: y = y + cury
    i = bcolor(y, x): IF bstat(y, x) > 0 THEN i = i - 256
    PUT #1, , i: PUT #1, , bkind(y, x)
    IF i < 0 THEN PUT #1, , stats(bstat(y, x))
   END IF
  NEXT y
 NEXT x
 x = 256: PUT #1, , x: PUT #1, , x: CLOSE #1
END SUB

